;***************************************************************
;*         aPLib v0.20b  -  the smaller the better :)          *
;*         NASM 16bit assembler tiny depacker example          *
;*                                                             *
;*   Copyright (c) 1998-99 by  Jibz  All Rights Reserved   *
;*    -> 16bit    METALBRAIN (metalb@www.esi.us.es)            *
;***************************************************************

                org     256
                mov     si,129
space1:         call    testitnow
                jz      space1
                dec     si
                mov     dx,si
space2:         call    testitnow
                jnz     space2
                mov     [si-1],byte 0
space3:         call    testitnow
                jz      space3
                dec     si
                mov     [nameout],si
space4:         lodsb
                cmp     al,13
                jz      nospace4
                cmp     al," "
                jnz     space4
nospace4:       mov     [si-1],byte 0
                mov     ax,3d00h
                int     33
                jc      finerr00
                mov     [handlein],ax
                mov     sp,inbuff
                xor     ebx,ebx
                mov     bx,es
                imul    esi,ebx,byte 16
                add     esi,esp
                lea     edi,[esi+32768]
                mov     [inbuff32],esi
                mov     [freemem32],edi
                add     [origin32],esi
                add     esi,98304+65536
                mov     [limit32],esi
                call    readinfile
                mov     dx,tmpname
                xor     cx,cx
                mov     ah,3ch
                int     33
                jnc     nofinerr
finerr00:       jmp     finerr
nofinerr:       mov     [handletmp],ax
                push    ax
                push    edi             ; Here starts DEPACK 16
                mov     dl,128
literal:        call    getesi
putedi_nexttag: call    putedi
                call    newtest
                jmp     short nexttag
normalcodepair: xchg    eax,ecx
                dec     eax
                shl     eax,8
                call    getesi
                mov     ebp,eax
                call    getgamma
                cmp     eax,32000
                jae     domatch_with_2inc
                cmp     eax,1280
                jae     domatch_with_inc
                cmp     eax,byte 127
                ja      domatch
domatch_with_2inc:
                inc     ecx
domatch_with_inc:
                inc     ecx
domatch:        push    esi
                mov     esi,edi
                sub     esi,eax
repmovsb:       call    getesi
                call    putedi
                mov     ah,128
                call    newtest
                loop    repmovsb,ecx
                pop     esi
nexttag:        call    getbit
                jnc     literal
                xor     ecx,ecx
                call    getbit
                jnc     codepair
                xor     eax,eax
                call    getbit
                jnc     shortmatch
                mov     al,16
getmorebits:    call    getbit
                adc     al,al
                jnc     getmorebits
                jnz     domatch_with_inc
                jmp     putedi_nexttag
codepair:       call    getgamma_no_ecx
                dec     ecx
                loop    normalcodepair,ecx
                mov     eax,ebp
                push    word domatch
getgamma:       xor     ecx,ecx
getgamma_no_ecx:inc     cx
getgammaloop:   call    getbit
                adc     ecx,ecx
                call    getbit
                jc      getgammaloop
                ret
shortmatch:     call    getesi
                shr     eax,1
                jz      donedepacking
                adc     ecx,ecx
                mov     ebp,eax
                jmp     short domatch_with_2inc
getbit:         add     dl,dl
                jnz     stillbitsleft
                pushf
                xchg    ax,dx
                call    getesi
                xchg    ax,dx
                popf
                adc     dl,dl
stillbitsleft:  ret
donedepacking:  pop     esi
                pop     bx
                sub     edi,esi         ; And here finish DEPACK 16
                xor     ecx,ecx
                push    ds
                mov     ch,0fah
more:           cmp     edi,ecx
                ja      notlast
                mov     cx,di
notlast:        push    esi
                pop     dx
                pop     ax
                ror     ax,4
                mov     ds,ax
                add     esi,ecx
                call    writefile
                sub     edi,ecx
                ja      more
                pop     ds
                push    ds
                pop     es
                mov     dx,[nameout]
                call    close_del
                jnc     renameit
                cmp     ax,5
                jz      finerr
renameit:       mov     ah,56h
                mov     di,dx
                mov     dx,tmpname
                int     33
                jc      finerr
                push    word noerr
final:          pop     dx
final_dxok:     mov     ah,9
                int     33
                int     20h             ; Exit program
writefile:      mov     ah,40h
                int     33
finerr04:       jc      finerr
                and     ax,ax
finerr03:       jnz     not_finerr
finerr:         mov     dx,tmpname
                push    word final_dxok
close_del:      mov     ah,3eh
                int     33
                mov     ah,41h
                int     33
not_finerr:     ret
getesi:         push    esi
                pop     bx
                pop     bx
                ror     bx,4
                mov     es,bx
                mov     al,[es:si]
                inc     esi
testinfile:     cmp     esi,[freemem32]
                jnz     getouttahere
readinfile:     pusha
                mov     ah,3fh
                mov     bx,[handlein]
                mov     cx,32768
                mov     dx,inbuff
                int     33
                jc      finerr04
                test    ax,ax
                jz      finerr03
                popa
                mov     esi,[inbuff32]
getouttahere:   ret
testitnow:      lodsb
                cmp     al,13
                jz      finerr03
                cmp     al," "
                ret
newtest:        cmp     edi,[limit32]
                jc      fintest
                pushad
                mov     dx,freemem
                mov     cx,32768
                mov     bx,[handletmp]
                call    writefile
                mov     ecx,edi
                mov     esi,[origin32]
                sub     ecx,esi
                mov     edi,[freemem32]
otherrepmovsb:  call    getesi
                call    putedi
                loop    otherrepmovsb,ecx
                popad
                sub     edi,32768
                sub     esi,eax
fintest:        ret
putedi:         push    edi
                pop     bx
                pop     bx
                ror     bx,4
                mov     es,bx
                mov     [es:di],al
                inc     edi
                xor     eax,eax
                ret
tmpname:
errmes:         db      "NOT "
noerr:          db      "OK$",0
origin32:       dd      65536
                SECTION .bss
nameout:        RESW 1
handletmp:      RESW 1
handlein:       RESW 1
inbuff32:       RESD 1
freemem32:      RESD 1
limit32:        RESD 1
                RESW 80                 ; Stack
inbuff:         RESB 32768              ; Infile reading buffer
freemem:
