;***************************************************************
;*         aPLib v0.20b  -  the smaller the better :)          *
;*            NASM 16bit assembler depacker example            *
;*                                                             *
;*   Copyright (c) 1998-99 by  Jibz  All Rights Reserved   *
;*    -> 16bit    METALBRAIN (metalb@www.esi.us.es)            *
;***************************************************************

                org     256
                mov     si,129
space1:         call    testitnow
                jz      space1
                dec     si
                mov     dx,si
space2:         call    testitnow
                jnz     space2
                mov     [si-1],byte 0
space3:         call    testitnow
                jz      space3
                dec     si
                mov     [nameout],si
space4:         lodsb
                cmp     al,13
                jz      nospace4
                cmp     al," "
                jnz     space4
nospace4:       mov     [si-1],byte 0
                mov     ax,3d00h
                int     33
                jnc     not_error001
                call    final
                db "Can't open infile$"
not_error001:   mov     [handlein],ax
                mov     sp,inbuff
                mov     bx,es
                movzx   edi,bx
                imul    esi,edi,byte 16
                add     esi,esp
                push    esi
                mov     edi,esi
                mov     [inbuff32],esi
                add     edi,32768       ; Infile buffer size
                mov     [freemem32],edi
                add     esi,65536
                mov     [origin32],esi
                add     esi,98304
                mov     [limit32],esi
                pop     esi
                call    readinfile
                mov     dx,tmpname
                mov     ah,3ch
                int     33
                jnc     not_error007    ; Can't open temporal outfile
                call    final
                db "Can't open temporal outfile$"
not_error007:   mov     [handletmp],ax
                push    edi             ; Here starts DEPACK 16
                mov     dl,128
literal:        call    getesi
putedi_nexttag: mov     [subtoesi+1],byte 0
                call    putedi
                jmp     short nexttag
normalcodepair: xchg    eax,ecx
                dec     eax
                shl     eax,8
                call    getesi
                mov     ebp,eax
                call    getgamma
                cmp     eax,32000
                jae     domatch_with_2inc
                cmp     eax,1280
                jae     domatch_with_inc
                cmp     eax,byte 127
                ja      domatch
domatch_with_2inc:
                inc     ecx
domatch_with_inc:
                inc     ecx
domatch:        push    esi
                mov     esi,edi
                sub     esi,eax
                mov     [subtoesi+1],byte 128
repmovsb:       call    getesi
                call    putedi
                loop    repmovsb,ecx
                pop     esi
nexttag:        call    getbit
                jnc     literal
                xor     ecx,ecx
                call    getbit
                jnc     codepair
                xor     eax,eax
                call    getbit
                jnc     shortmatch
                mov     al,16
getmorebits:    call    getbit
                adc     al,al
                jnc     getmorebits
                jnz     domatch_with_inc
                jmp     putedi_nexttag
codepair:       call    getgamma_no_ecx
                dec     ecx
                loop    normalcodepair,ecx
                mov     eax,ebp
                push    word domatch
getgamma:       xor     ecx,ecx
getgamma_no_ecx:inc     cx
getgammaloop:   call    getbit
                adc     ecx,ecx
                call    getbit
                jc      getgammaloop
                ret
shortmatch:     call    getesi
                shr     eax,1
                jz      donedepacking
                adc     ecx,ecx
                mov     ebp,eax
                jmp     short domatch_with_2inc
getbit:         add     dl,dl
                jnz     stillbitsleft
                pushf
                xchg    ax,dx
                call    getesi
                xchg    ax,dx
                popf
                adc     dl,dl
stillbitsleft:  ret
donedepacking:  pop     esi
                sub     edi,esi         ;And here finish DEPACK 16
                xor     ecx,ecx
                mov     bx,[handletmp]
                push    ds
                mov     ch,0fah
more:           cmp     edi,ecx
                ja      notlast
                mov     cx,di
notlast:        push    esi
                pop     dx
                pop     ax
                ror     ax,4
                mov     ds,ax
                add     esi,ecx
                mov     ah,40h
                int     33              ; Write 64000 or last bytes
                jc      error005
                and     ax,ax
                jz      error006
                sub     edi,ecx
                ja      more
                pop     ds
                push    ds
                pop     es
                mov     ah,3eh
                int     33
                mov     ah,41h
                mov     dx,[nameout]
                int     33
                jnc     renameit
                cmp     ax,5
                jz      error002b
renameit:       mov     ah,56h
                mov     di,dx
                mov     dx,tmpname
                int     33
                jc      error002
                push    word noerr
final:          pop     dx
                mov     ah,9
                int     33
                int     20h             ; Exit program
error002b:      push    word err002b
                jmp     short rub4
error002:       push    word err002
                jmp     short rub4
error005:       pop     ds
error005b:      push    word err005
                jmp     short rub3
error006:       pop     ds
error006b:      push    word err006
rub3:           mov     ah,3eh
                int     33
rub4:           mov     dx,tmpname
                mov     ah,41h
                int     33
                jmp     short final
readinfile:     mov     ah,3fh
                mov     bx,[handlein]
                mov     cx,32768
                mov     dx,inbuff
                int     33
                jc      error003
noerror003:     test    ax,ax
                jnz     noerror004
                push    word err004
                jmp     short error004
error003:       push    word err003
error004:       mov     bx,[handletmp]
                jmp     short rub3
testitnow:      lodsb
                cmp     al,13
                jz      error000
                cmp     al," "
noerror004:     ret
putedi:         push    edi
                pop     bx
                pop     bx
                ror     bx,4
                mov     es,bx
                mov     [es:di],al
                inc     edi
                cmp     edi,[limit32]
                jc      fintests
                pushad
                mov     dx,freemem
                mov     cx,32768
                mov     bx,[handletmp]
                mov     ah,40h
                int     33
                jc      error005b
                cmp     ax,cx
                jnz     error006b
                mov     esi,[origin32]
                mov     edi,[freemem32]
                mov     ecx,98304
otherrepmovsb:  call    getesi
                call    putedi
                loop    otherrepmovsb,ecx
                popad
                sub     edi,32768
                sub     esi,[subtoesi]
fintests:       ret
getesi:         push    esi
                pop     bx
                pop     bx
                ror     bx,4
                mov     es,bx
                mov     al,[es:si]
                inc     esi
testinfile:     cmp     esi,[freemem32]
                jnz     fintests
                pusha
                call    readinfile
                popa
                mov     esi,[inbuff32]
                ret
error000:       call    final
                db "Usage: DEPPACK infile outfile",13,10,10
                db "infile must be an aPPACKed file",13,10
                db "drives, paths and wildcards are not allowed",13,10,10
                db "DEPPACK v0.3 Copyright (c) 1998-99 by  METALBRAIN",13,10
                db "aPLib v0.20b Copyright (c) 1998-99 by  Jibz  All Rights Reserved$"
err005:         db "Can't write temporal outfile$"
err002b:        db "Outfile is protected, so...",13,10
err002:         db "Can't open outfile$"
err003:         db "Can't read from infile$"
err004:         db "Bad infile$"
err006:         db "Disk full$"
noerr:          db "Deppacking ok$"
tmpname:        db ""
subtoesi:       dd 0

                SECTION .bss
nameout:        RESW 1
handletmp:      RESW 1
handlein:       RESW 1
inbuff32:       RESD 1
freemem32:      RESD 1
origin32:       RESD 1
limit32:        RESD 1
                RESW 80                 ; Stack
inbuff:         RESB 32768              ; Infile reading buffer
freemem:
